/////////////////////////////////////////////////////////////////////////////
//
//  Soubor: WinApiComboBox.cpp
//	
//  (C) 2002 Radek Chalupa
//
/////////////////////////////////////////////////////////////////////////////

#define WINVER 0x0500
#define _WIN32_WINNT 0x0501

#include <windows.h>
#include <tchar.h>
#include <stdio.h>

#include "resource.h"

void NaInitDialog(HWND hWnd)
{

	SendDlgItemMessage(hWnd, IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)
		_T("1. dek"));
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)_T("2. dek"));
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)
		_T("3. dek tady bude njak dost dlouh text"));
		
	TCHAR szText[100];
	SendDlgItemMessage(hWnd, IDC_COMBO, WM_SETREDRAW, FALSE, 0);
	for ( int i = 4; i < 10000; i++ )
	{
		_stprintf(szText, _T("dek %d. pidn ve %d ms"), i, (int)GetTickCount());
		SendDlgItemMessage(hWnd, IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)szText);
	}
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_SETCURSEL, 2, 0);
	SendDlgItemMessage(hWnd, IDC_COMBO, WM_SETREDRAW, TRUE, 0);
	SendMessage(hWnd, WM_SETICON, ICON_SMALL,
		(LPARAM)LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_HLAVNI)));
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_SETDROPPEDWIDTH, 350, 0);
}


void ZjistiTextPolozky(HWND hCombo)
{
	LPTSTR lpText;
	LRESULT vyber = SendMessage(hCombo, CB_GETCURSEL, 0, 0);
	LRESULT delkaTextu = SendMessage(hCombo, CB_GETLBTEXTLEN, vyber, 0);
	lpText = (LPTSTR)HeapAlloc(GetProcessHeap(), 0,
		(delkaTextu+1) * sizeof(TCHAR));
	SendMessage(hCombo, CB_GETLBTEXT, vyber, (LPARAM)lpText);
	SetDlgItemText(GetParent(hCombo), IDC_COMBO_TEXT, lpText);
	HeapFree(GetProcessHeap(), 0, lpText);
}

void NaRozbalit(HWND hWnd)
{
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_SHOWDROPDOWN, TRUE, 0);
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_SETTOPINDEX,	(WPARAM)200, 0);
}

void NaComboInfo(HWND hWnd)
{
	COMBOBOXINFO cbi;
	ZeroMemory(&cbi, sizeof(cbi));
	cbi.cbSize = sizeof(cbi);
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_GETCOMBOBOXINFO, 0, (LPARAM)&cbi);
	SetWindowText((HWND)cbi.hwndItem, _T("Vlastn text"));
	SendMessage((HWND)cbi.hwndList, WM_SETFONT,
		(WPARAM)GetStockObject(ANSI_FIXED_FONT), TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// Procedura dialogu

INT_PTR CALLBACK DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
		case WM_COMMAND:
			switch ( LOWORD(wParam) )
			{
				case IDOK:
					EndDialog(hWnd, IDOK);
					break;
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
				case IDC_ROZBALIT:
					NaRozbalit(hWnd);
					break;
				case IDC_COMBO_INFO:
					NaComboInfo(hWnd);
					break;
			}
			break;
		case WM_INITDIALOG:
			NaInitDialog(hWnd);
			break;
	}
	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Hlavn funkce programu pro Windows

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_HLAVNI), NULL, DialogProc);
	return 0;
}
